import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * General movement patterns for all classes
 * 
 * @author Azhar Chaudhry 
 * @version 1.2
 */
public class Mover extends Actor
{
    protected int velocity;
    protected int outOfBoundary;
    protected int xFirePosition;
    protected int yFirePosition;

    protected void moveLeft(){
        setLocation (getX() - velocity, getY());
    }

    protected void moveRight(){
        setLocation (getX() + velocity, getY());
    }

    protected void moveDown(){
        setLocation (getX(), getY() + velocity);
    }

    protected void moveUp(){
        setLocation (getX(), getY() - velocity);
    }
    
    protected void turnLeft(){
        turn(-362);
    }
    
    protected void turnRight(){
        turn(362);
    }
    

    protected void moveUpDownPattern(){
        setLocation (getX(), getY() + velocity );
        if (velocity < 0 && getY() <= 30)
        { // moving up
            setLocation(getX(), 30); // reset position
            velocity = - velocity; // change direction
        }
        if (velocity > 0 && getY() >= 357)
        { // moving down
            setLocation(getX(), 357); // reset position
            velocity = - velocity; // change direction
        }
    }

    protected void moveDownUpPattern(){
        setLocation (getX(), getY() + velocity);
        if (velocity > 0 && getY() >= 357)
        { // moving up
            setLocation(getX(), 357); // reset position
            velocity = -velocity; // change direction
        }
        if (velocity < 0 && getY() <= 30)
        { // moving down
            setLocation(getX(), 30); // reset position
            velocity = -velocity; // change direction
        }
    }

    protected void moveSqaurePattern(){
        setLocation ( getX() + velocity, getY());
        if (velocity < 0 && getX() <= 266)
        { // moving left and past left limit
            setLocation(266, getY()); // reset position
            setLocation ( 266, getY() + velocity );
            if (velocity < 0 && getY() <= -100)
            { // moving up
                setLocation(getX(), -100); // reset position
                velocity = -velocity; // change direction
            }
            if (velocity > 0 && getY() >= 300)
            { // moving down
                setLocation(getX(), 300); // reset position
                velocity = -velocity; // change direction
            }
        }
        if (velocity > 0 && getX() >= 1140)
        { // moving right and past right limit
            setLocation(1140, getY()); // reset position
            setLocation ( 1140, getY() + velocity );
            if (velocity < 0 && getY() <= 81)
            { // moving up
                setLocation(getX(), 81); // reset position
                velocity = -velocity; // change direction
            }
            if (velocity > 0 && getY() >= 318)
            { // moving down
                setLocation(getX(), 318); // reset position
                velocity = -velocity; // change direction
            }
        }
    }
    
     protected void moveLeftRightPattern(){
       setLocation ( getX() + velocity, getY());
        if (velocity < 0 && getX() <= 137)
        { // moving left and past left limit
            setLocation(137, getY()); // reset position
            velocity = -velocity; // change direction
        }
        if (velocity > 0 && getX() >= 1150)
        { // moving right and past right limit
            setLocation(1150, getY()); // reset position
            velocity = -velocity; // change direction
        }
    }
}